/* I hacked this out of ControlServer... it should be jsut things to do 
   with talking to the audio programs.  
   					     CRW Sun Oct  8 21:35:19 1995 */

/* This is a sample control program (with no graphics) using the Control
   Library.  It's currently configured to control DOOM.

                                             KBR 8/94 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>

/* private constants and variables */

#define AUDIO_BUFFER_LENGTH 128
#define AUDIO_WINDOW_LENGTH 5
static float AUDIO_EXPIRE_TIME = 0.5;  /* half a second */

static int use_threshold = 0;
static FILE *audio_fp;
		
static int weapon_fire =0;
static int weapon_num  =2;

/* private functions */

static float
timevalDifference(struct timeval* tv2,
		  struct timeval* tv1)
{
  register float dt;
  dt  = (float) (tv2->tv_usec - tv1->tv_usec);
  dt *= 1.0e-6;
  dt += (float) (tv2->tv_sec - tv1->tv_sec);
  return (dt);
}

static int
slideWindowAlongBuffer(char *buf, int num_bytes, int reset)
{
  static char window[AUDIO_WINDOW_LENGTH];
  int latest_hit = '0';
  
  if (reset)
    {
      int counter;
      for (counter = 0; counter < AUDIO_WINDOW_LENGTH; counter++)
	window[counter] = '0';
    }
  else
    {
      /* copy buf into window a byte at a time */
      /* check window to see if we've gotten a 'hit' */
      int c1;
      int c2;

      for (c1 = 0; c1 < num_bytes; c1++)
	{
	  for (c2 = 0; c2 < AUDIO_WINDOW_LENGTH-1; c2++)
	    {
	      window[c2] = window[c2+1];
	    }
	  window[AUDIO_WINDOW_LENGTH-1] = buf[c1];
	  
	  /* if we've got a solid window of some character (i.e. 4 or 5), */
	  /* return that character */

	  {
	    char temp = window[0];
	    int hit_flag = 1;
	    for (c2 = 1; c2 < AUDIO_WINDOW_LENGTH; c2++)
	      {
		if (temp != window[c2])
		  hit_flag = 0;
	      }
	    if (hit_flag == 1)
	      {
		latest_hit = temp;
		fprintf(stderr,"Got a hit: %c\n", latest_hit);
	      }
	  }
	}
    }
  return latest_hit - '0';
}

/* public functions */

int amt_audio_weapon() { return (weapon_num); }
int amt_audio_fire()   { return (weapon_fire); }

void amt_audio_update()
{
  static char buffer[AUDIO_BUFFER_LENGTH];
  static int current_weapon = 1, old_weapon = 1, last_weapon = 1;
  static struct timeval last_time_sound_heard = {0, 0};
  static int should_reset_audio = 1;
  
  struct timeval current_time;
  int nread;
  
  if (last_time_sound_heard.tv_sec == 0)
    gettimeofday(&last_time_sound_heard); 
  
  nread = read(fileno(audio_fp), buffer, AUDIO_BUFFER_LENGTH);
  if (nread > 0)
    {
      fprintf(stderr,"Heard something\n");
      gettimeofday(&last_time_sound_heard);
      weapon_fire = 1;
      
      if (!use_threshold)
	{
	  int new_weapon = slideWindowAlongBuffer(buffer, 
						  nread, 
						  should_reset_audio);
	  if (new_weapon)
	    {
	      weapon_num = new_weapon;
	      fprintf(stderr,"Switching to weapon to %d\n",new_weapon);
	    }
	}
    }
  else
    {
      if (nread == 0)
	{
	  /* give the firing a little buffering */
	  gettimeofday(&current_time);
	  
	  if (timevalDifference(&current_time, 
				&last_time_sound_heard) > AUDIO_EXPIRE_TIME)
	    {
	      should_reset_audio = 1;
	      weapon_fire = 0;
	    }
	  else
	    {
	      should_reset_audio = 0;
	      weapon_fire = 1;
	    }
	}
      else
	fprintf(stderr, "Error reading audio data: %d\n", nread);
    }
}

void amt_audio_init()
{
  int c;
  char sound_cmd[255];
  char *sound_dir;
  char *sound_display;
  char *sound_host;

  sound_dir     = getenv("SURVIVE_SOUND_DIR");
  sound_display = getenv("HOST");
  sound_host    = getenv("SURVIVE_SOUND_SERVER");

  if (getenv("SURVIVE_THRESHOLD"))
    use_threshold = 1;

  /* add the sound controller */
  fprintf(stderr, "Waiting for sound connection\n");
  do
    {
      if (!use_threshold)
	{
	  sprintf(sound_cmd, 
		  "rsh %s 'setenv TERM xterm; \
                           setenv DISPLAY %s:0.0; \
                           cd %s; \
                           xrdb -merge TestSlider.ad; \
                           fftsample -r'", 
		  sound_host,
		  sound_display,
		  sound_dir);

	  fprintf(stderr, "%s\n", sound_cmd);
	  audio_fp = popen(sound_cmd, "r");
	}
      else
	{
	  sprintf(sound_cmd, 
		  "rsh %s 'setenv TERM xterm; \
                           setenv DISPLAY %s:0.0; \
                           cd %s; \
                           athresh'", 
		  sound_host,
		  sound_display,
		  sound_dir);
	  fprintf(stderr, "%s\n", sound_cmd);
	  audio_fp = popen(sound_cmd, "r");
	}

      if (fileno(audio_fp) < 1)
	{
	  fprintf(stderr,"connection refused: %d\n", audio_fp);
	  sleep(1);
	}
      else
	{
	  /* enable non blocking IO on the sound connection */
	  int flags;
	  int audio_fd = fileno(audio_fp);

	  fcntl(audio_fd, F_SETOWN, getpid());
	  flags = fcntl(audio_fd, F_GETFL, 0);
	  flags |= FASYNC;
	  flags |= O_NDELAY;
	  fcntl(audio_fd, F_SETFL, flags);

	  fprintf(stderr, "Sound connection established\n");
	}
    }
  while (fileno(audio_fp) < 1);
}
